
#include 'DbfDbe.ch'
#include 'CdxDbe.ch'
#include 'FoxDbE.ch'
PROCEDURE Main()
LOCAL  aDbe, nLenDbes, nInd, lOk, bError, xReturned
cls
LoadDbe()
                  //
                  //    Obtemos a lista dos DBEs carregados
aDbe      := DbeList()
nLenDbes  := Len(aDbe)
for nInd  := 1 to nLenDbes
    if aDbe[nInd, 2]
       ADel(aDbe, nInd)
       nInd     -= 1
       nLenDbes -= 1
    endif
next

lOk      := .f.
bError   := ErrorBlock({|e| Break(e)})
for nInd := 1 to nLenDbes
BEGIN SEQUENCE
      DbUseArea(.t., aDbe[nInd, 1], '0002', 'f0002', .f., .t.)    // Not shared, readonly
      xReturned := f0002->(DbInfo(DBFDBO_ANSI))
      if     ValType(xReturned) == 'L'
             xReturned          := ('Returned values is ' + iif(xReturned, 'CHARSET_ANSI', 'CHARSET_OEM'))
      elseif (xReturned         == 437   .or.;
              (xReturned        >= 737   .and.;
               xReturned        <= 869))
             xReturned          := ('Returned values is ' + LTrim(Str(xReturned)) +  ', CHARSET_OEM')
      elseif xReturned          >= 1250  .and.;
             xReturned          <= 1258
             xReturned          := ('Returned values is ' + LTrim(Str(xReturned)) +  ', CHARSET_ANSI')
      else
             xReturned          := ('Returned values neither is ANSI nor OEM: ' + LTrim(Str(xReturned)))
      endif
      lOk := .t.
RECOVER
ENDSEQUENCE
    if lOk
       if xReturned == NIL
          xReturned := 'Error in DbInfo()'
       endif
       exit
    endif
next
ErrorBlock(bError)
if lOk
   wait xReturned
else
   QOut(xReturned)
   Wait 'Nothing worked'
endif
RETURN

STATIC FUNCTION LoadDbe()
DbeLoad('foxdbe', .t.)
DbeLoad('cdxdbe', .t.)                             // CDX

if !DbeBuild('FoxCdx', 'foxdbe', 'cdxdbe' )
   QOut('FOXCDX Database-Engine: could not build engine', .f.)
   Quit
endif
DbeInfo(COMPONENT_DATA,  FOXDBE_LOCKRETRY, 100000)
DbeInfo(COMPONENT_DATA,  FOXDBE_LOCKDELAY,     10)
DbeInfo(COMPONENT_DATA,  FOXDBE_LIFETIME,      20)

DbeInfo(COMPONENT_ORDER, CDXDBE_LOCKRETRY, 100000)
DbeInfo(COMPONENT_ORDER, CDXDBE_LOCKDELAY,     10)
DbeInfo(COMPONENT_ORDER, CDXDBE_MODE,  CDXDBE_VFOXPRO)

DbeInfo(COMPONENT_ORDER, DBE_LOCKMODE, LOCKING_EXTENDED)
DbeSetDefault('FoxCdx')
return NIL